#!/usr/bin/perl

#############################################################################
#
# This Perl script scans the log file of the coordinator
# and computes the sum of times of processing all the chunks of data.
#
#############################################################################

# Copyright (C) 1997-2014 by Pawel Pilarczyk.
#
# This file is part of my research software package. This is free software:
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later version.
#
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; see the file "license.txt". If not,
# please, see <https://www.gnu.org/licenses/>.

# Started on May 2, 2008. Last revision: May 2, 2008.


die "Call this script with the names of coordinator's log files.\n"
	if (scalar (@ARGV) < 1);
my @files = @ARGV;


sub showtime
{
	my $title = shift;
	my $sum = shift;
	my $sum_m = int ($sum * 10 / 6) / 100.0;
	my $sum_h = int ($sum / 36) / 100.0;
	print "$title: $sum seconds = $sum_m minutes = $sum_h hours.\n";
}


my $totaltime = 0.0;
foreach my $filename (@files)
{
	# open the file
	print "Log file '$filename'...\n";
	open (FILE, "$filename") or
		(print ("! Can't open the file. Skipping it.\n") and next);

	# scan the file
	while (<FILE>)
	{
		next unless /\(processed in ([\d\.e\-\+]+) sec\)/;
		$totaltime += $1;
	}
	close FILE;
}

# display result
showtime ("Total time (single CPU)", int ($totaltime));
showtime ("Total time (42 cluster)", int ($totaltime / 42));

